diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/post.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/post.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/post.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/post.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 3174,3189 ****
  /**
   * Retrieves page data given a page ID or page object.
   *
   * @since 1.5.1
   *
   * @param mixed $page Page object or page ID. Passed by reference.
   * @param string $output What to output. OBJECT, ARRAY_A, or ARRAY_N.
   * @param string $filter How the return value should be filtered.
!  * @return mixed Page data.
   */
! function &get_page(&$page, $output = OBJECT, $filter = 'raw') {
! 	$p = get_post($page, $output, $filter);
! 	return $p;
  }
  
  /**
--- 3411,3428 ----
  /**
   * Retrieves page data given a page ID or page object.
   *
+  * Use get_post() instead of get_page().
+  *
   * @since 1.5.1
+  * @deprecated 3.5.0
   *
   * @param mixed $page Page object or page ID. Passed by reference.
   * @param string $output What to output. OBJECT, ARRAY_A, or ARRAY_N.
   * @param string $filter How the return value should be filtered.
!  * @return WP_Post|null WP_Post on success or null on failure
   */
! function get_page( $page, $output = OBJECT, $filter = 'raw') {
! 	return get_post( $page, $output, $filter );
  }
  
  /**
***************
*** 3195,3201 ****
   * @param string $page_path Page path
   * @param string $output Optional. Output type. OBJECT, ARRAY_N, or ARRAY_A. Default OBJECT.
   * @param string $post_type Optional. Post type. Default page.
!  * @return mixed Null when complete.
   */
  function get_page_by_path($page_path, $output = OBJECT, $post_type = 'page') {
  	global $wpdb;
--- 3434,3440 ----
   * @param string $page_path Page path
   * @param string $output Optional. Output type. OBJECT, ARRAY_N, or ARRAY_A. Default OBJECT.
   * @param string $post_type Optional. Post type. Default page.
!  * @return WP_Post|null WP_Post on success or null on failure
   */
  function get_page_by_path($page_path, $output = OBJECT, $post_type = 'page') {
  	global $wpdb;
***************
*** 3210,3216 ****
  	$in_string = "'". implode( "','", $parts ) . "'";
  	$post_type_sql = $post_type;
  	$wpdb->escape_by_ref( $post_type_sql );
! 	$pages = $wpdb->get_results( "SELECT ID, post_name, post_parent FROM $wpdb->posts WHERE post_name IN ($in_string) AND (post_type = '$post_type_sql' OR post_type = 'attachment')", OBJECT_K );
  
  	$revparts = array_reverse( $parts );
  
--- 3449,3455 ----
  	$in_string = "'". implode( "','", $parts ) . "'";
  	$post_type_sql = $post_type;
  	$wpdb->escape_by_ref( $post_type_sql );
! 	$pages = $wpdb->get_results( "SELECT ID, post_name, post_parent, post_type FROM $wpdb->posts WHERE post_name IN ($in_string) AND (post_type = '$post_type_sql' OR post_type = 'attachment')", OBJECT_K );
  
  	$revparts = array_reverse( $parts );
  
***************
*** 3229,3241 ****
  
  			if ( $p->post_parent == 0 && $count+1 == count( $revparts ) && $p->post_name == $revparts[ $count ] ) {
  				$foundid = $page->ID;
! 				break;
  			}
  		}
  	}
  
  	if ( $foundid )
! 		return get_page( $foundid, $output );
  
  	return null;
  }
--- 3468,3481 ----
  
  			if ( $p->post_parent == 0 && $count+1 == count( $revparts ) && $p->post_name == $revparts[ $count ] ) {
  				$foundid = $page->ID;
! 				if ( $page->post_type == $post_type )
! 					break;
  			}
  		}
  	}
  
  	if ( $foundid )
! 		return get_post( $foundid, $output );
  
  	return null;
  }
***************
*** 3249,3261 ****
   * @param string $page_title Page title
   * @param string $output Optional. Output type. OBJECT, ARRAY_N, or ARRAY_A. Default OBJECT.
   * @param string $post_type Optional. Post type. Default page.
!  * @return mixed
   */
  function get_page_by_title($page_title, $output = OBJECT, $post_type = 'page' ) {
  	global $wpdb;
  	$page = $wpdb->get_var( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_title = %s AND post_type= %s", $page_title, $post_type ) );
  	if ( $page )
! 		return get_page($page, $output);
  
  	return null;
  }
--- 3489,3501 ----
   * @param string $page_title Page title
   * @param string $output Optional. Output type. OBJECT, ARRAY_N, or ARRAY_A. Default OBJECT.
   * @param string $post_type Optional. Post type. Default page.
!  * @return WP_Post|null WP_Post on success or null on failure
   */
  function get_page_by_title($page_title, $output = OBJECT, $post_type = 'page' ) {
  	global $wpdb;
  	$page = $wpdb->get_var( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_title = %s AND post_type= %s", $page_title, $post_type ) );
  	if ( $page )
! 		return get_post( $page, $output );
  
  	return null;
  }
***************
*** 3273,3279 ****
   * @param array $pages List of pages' objects.
   * @return array
   */
! function &get_page_children($page_id, $pages) {
  	$page_list = array();
  	foreach ( (array) $pages as $page ) {
  		if ( $page->post_parent == $page_id ) {
--- 3513,3519 ----
   * @param array $pages List of pages' objects.
   * @return array
   */
! function get_page_children($page_id, $pages) {
  	$page_list = array();
  	foreach ( (array) $pages as $page ) {
  		if ( $page->post_parent == $page_id ) {
***************
*** 3297,3303 ****
   * @param int $page_id Parent page ID.
   * @return array A list arranged by hierarchy. Children immediately follow their parents.
   */
! function &get_page_hierarchy( &$pages, $page_id = 0 ) {
  	if ( empty( $pages ) ) {
  		$result = array();
  		return $result;
--- 3537,3543 ----
   * @param int $page_id Parent page ID.
   * @return array A list arranged by hierarchy. Children immediately follow their parents.
   */
! function get_page_hierarchy( &$pages, $page_id = 0 ) {
  	if ( empty( $pages ) ) {
  		$result = array();
  		return $result;
***************
*** 3342,3357 ****
   */
  function get_page_uri($page) {
  	if ( ! is_object($page) )
! 		$page = get_page($page);
  	$uri = $page->post_name;
  
! 	// A page cannot be it's own parent.
! 	if ( $page->post_parent == $page->ID )
! 		return $uri;
! 
! 	while ($page->post_parent != 0) {
! 		$page = get_page($page->post_parent);
! 		$uri = $page->post_name . "/" . $uri;
  	}
  
  	return $uri;
--- 3582,3592 ----
   */
  function get_page_uri($page) {
  	if ( ! is_object($page) )
! 		$page = get_post( $page );
  	$uri = $page->post_name;
  
! 	foreach ( $page->ancestors as $parent ) {
! 		$uri = get_post( $parent )->post_name . "/" . $uri;
  	}
  
  	return $uri;
***************
*** 3370,3378 ****
   * @param mixed $args Optional. Array or string of options that overrides defaults.
   * @return array List of pages matching defaults or $args
   */
! function &get_pages($args = '') {
  	global $wpdb;
  
  	$defaults = array(
  		'child_of' => 0, 'sort_order' => 'ASC',
  		'sort_column' => 'post_title', 'hierarchical' => 1,
--- 3605,3615 ----
   * @param mixed $args Optional. Array or string of options that overrides defaults.
   * @return array List of pages matching defaults or $args
   */
! function get_pages($args = '') {
  	global $wpdb;
  
+ 	$pages = false;
+ 
  	$defaults = array(
  		'child_of' => 0, 'sort_order' => 'ASC',
  		'sort_column' => 'post_title', 'hierarchical' => 1,
***************
*** 3391,3409 ****
  	// Make sure the post type is hierarchical
  	$hierarchical_post_types = get_post_types( array( 'hierarchical' => true ) );
  	if ( !in_array( $post_type, $hierarchical_post_types ) )
! 		return false;
  
  	// Make sure we have a valid post status
  	if ( !is_array( $post_status ) )
  		$post_status = explode( ',', $post_status );
  	if ( array_diff( $post_status, get_post_stati() ) )
! 		return false;
  
  	$cache = array();
  	$key = md5( serialize( compact(array_keys($defaults)) ) );
  	if ( $cache = wp_cache_get( 'get_pages', 'posts' ) ) {
! 		if ( is_array($cache) && isset( $cache[ $key ] ) ) {
! 			$pages = apply_filters('get_pages', $cache[ $key ], $r );
  			return $pages;
  		}
  	}
--- 3628,3648 ----
  	// Make sure the post type is hierarchical
  	$hierarchical_post_types = get_post_types( array( 'hierarchical' => true ) );
  	if ( !in_array( $post_type, $hierarchical_post_types ) )
! 		return $pages;
  
  	// Make sure we have a valid post status
  	if ( !is_array( $post_status ) )
  		$post_status = explode( ',', $post_status );
  	if ( array_diff( $post_status, get_post_stati() ) )
! 		return $pages;
  
  	$cache = array();
  	$key = md5( serialize( compact(array_keys($defaults)) ) );
  	if ( $cache = wp_cache_get( 'get_pages', 'posts' ) ) {
! 		if ( is_array($cache) && isset( $cache[ $key ] ) && is_array( $cache[ $key ] ) ) {
! 			// Convert to WP_Post instances
! 			$pages = array_map( 'get_post', $cache[ $key ] );
! 			$pages = apply_filters( 'get_pages', $pages, $r );
  			return $pages;
  		}
  	}
***************
*** 3559,3565 ****
  	update_post_cache( $pages );
  
  	if ( $child_of || $hierarchical )
! 		$pages = & get_page_children($child_of, $pages);
  
  	if ( !empty($exclude_tree) ) {
  		$exclude = (int) $exclude_tree;
--- 3798,3804 ----
  	update_post_cache( $pages );
  
  	if ( $child_of || $hierarchical )
! 		$pages = get_page_children($child_of, $pages);
  
  	if ( !empty($exclude_tree) ) {
  		$exclude = (int) $exclude_tree;
***************
*** 3578,3583 ****
--- 3817,3825 ----
  	$cache[ $key ] = $pages;
  	wp_cache_set( 'get_pages', $cache, 'posts' );
  
+ 	// Convert to WP_Post instances
+ 	$pages = array_map( 'get_post', $pages );
+ 
  	$pages = apply_filters('get_pages', $pages, $r);
  
  	return $pages;
***************
*** 3601,3607 ****
  	if (strpos($url, home_url('/?attachment_id=')) !== false)
  		return true;
  	if ( $id = url_to_postid($url) ) {
! 		$post = & get_post($id);
  		if ( 'attachment' == $post->post_type )
  			return true;
  	}
--- 3843,3849 ----
  	if (strpos($url, home_url('/?attachment_id=')) !== false)
  		return true;
  	if ( $id = url_to_postid($url) ) {
! 		$post = get_post($id);
  		if ( 'attachment' == $post->post_type )
  			return true;
  	}
***************
*** 3676,3688 ****
  	if ( ! in_array( $post_status, array( 'inherit', 'private' ) ) )
  		$post_status = 'inherit';
  
  	// Make sure we set a valid category.
! 	if ( !isset($post_category) || 0 == count($post_category) || !is_array($post_category) ) {
! 		// 'post' requires at least one category.
! 		if ( 'post' == $post_type )
! 			$post_category = array( get_option('default_category') );
! 		else
! 			$post_category = array();
  	}
  
  	// Are we updating or creating?
--- 3918,3929 ----
  	if ( ! in_array( $post_status, array( 'inherit', 'private' ) ) )
  		$post_status = 'inherit';
  
+ 	if ( !empty($post_category) )
+ 		$post_category = array_filter($post_category); // Filter out empty terms
+ 
  	// Make sure we set a valid category.
! 	if ( empty($post_category) || 0 == count($post_category) || !is_array($post_category) ) {
! 		$post_category = array();
  	}
  
  	// Are we updating or creating?
***************
*** 3767,3773 ****
  		$wpdb->update( $wpdb->posts, compact("post_name"), array( 'ID' => $post_ID ) );
  	}
  
! 	wp_set_post_categories($post_ID, $post_category);
  
  	if ( $file )
  		update_attached_file( $post_ID, $file );
--- 4008,4029 ----
  		$wpdb->update( $wpdb->posts, compact("post_name"), array( 'ID' => $post_ID ) );
  	}
  
! 	if ( is_object_in_taxonomy($post_type, 'category') )
! 		wp_set_post_categories( $post_ID, $post_category );
! 
! 	if ( isset( $tags_input ) && is_object_in_taxonomy($post_type, 'post_tag') )
! 		wp_set_post_tags( $post_ID, $tags_input );
! 
! 	// support for all custom taxonomies
! 	if ( !empty($tax_input) ) {
! 		foreach ( $tax_input as $taxonomy => $tags ) {
! 			$taxonomy_obj = get_taxonomy($taxonomy);
! 			if ( is_array($tags) ) // array = hierarchical, string = non-hierarchical.
! 				$tags = array_filter($tags);
! 			if ( current_user_can($taxonomy_obj->cap->assign_terms) )
! 				wp_set_post_terms( $post_ID, $tags, $taxonomy );
! 		}
! 	}
  
  	if ( $file )
  		update_attached_file( $post_ID, $file );
***************
*** 3897,3903 ****
   */
  function wp_get_attachment_metadata( $post_id = 0, $unfiltered = false ) {
  	$post_id = (int) $post_id;
! 	if ( !$post =& get_post( $post_id ) )
  		return false;
  
  	$data = get_post_meta( $post->ID, '_wp_attachment_metadata', true );
--- 4153,4159 ----
   */
  function wp_get_attachment_metadata( $post_id = 0, $unfiltered = false ) {
  	$post_id = (int) $post_id;
! 	if ( !$post = get_post( $post_id ) )
  		return false;
  
  	$data = get_post_meta( $post->ID, '_wp_attachment_metadata', true );
***************
*** 3919,3930 ****
   */
  function wp_update_attachment_metadata( $post_id, $data ) {
  	$post_id = (int) $post_id;
! 	if ( !$post =& get_post( $post_id ) )
  		return false;
  
! 	$data = apply_filters( 'wp_update_attachment_metadata', $data, $post->ID );
! 
! 	return update_post_meta( $post->ID, '_wp_attachment_metadata', $data);
  }
  
  /**
--- 4175,4187 ----
   */
  function wp_update_attachment_metadata( $post_id, $data ) {
  	$post_id = (int) $post_id;
! 	if ( !$post = get_post( $post_id ) )
  		return false;
  
! 	if ( $data = apply_filters( 'wp_update_attachment_metadata', $data, $post->ID ) )
! 		return update_post_meta( $post->ID, '_wp_attachment_metadata', $data );
! 	else
! 		return delete_post_meta( $post->ID, '_wp_attachment_metadata' );
  }
  
  /**
***************
*** 3937,3943 ****
   */
  function wp_get_attachment_url( $post_id = 0 ) {
  	$post_id = (int) $post_id;
! 	if ( !$post =& get_post( $post_id ) )
  		return false;
  
  	if ( 'attachment' != $post->post_type )
--- 4194,4200 ----
   */
  function wp_get_attachment_url( $post_id = 0 ) {
  	$post_id = (int) $post_id;
! 	if ( !$post = get_post( $post_id ) )
  		return false;
  
  	if ( 'attachment' != $post->post_type )
***************
*** 3976,3982 ****
   */
  function wp_get_attachment_thumb_file( $post_id = 0 ) {
  	$post_id = (int) $post_id;
! 	if ( !$post =& get_post( $post_id ) )
  		return false;
  	if ( !is_array( $imagedata = wp_get_attachment_metadata( $post->ID ) ) )
  		return false;
--- 4233,4239 ----
   */
  function wp_get_attachment_thumb_file( $post_id = 0 ) {
  	$post_id = (int) $post_id;
! 	if ( !$post = get_post( $post_id ) )
  		return false;
  	if ( !is_array( $imagedata = wp_get_attachment_metadata( $post->ID ) ) )
  		return false;
***************
*** 3998,4004 ****
   */
  function wp_get_attachment_thumb_url( $post_id = 0 ) {
  	$post_id = (int) $post_id;
! 	if ( !$post =& get_post( $post_id ) )
  		return false;
  	if ( !$url = wp_get_attachment_url( $post->ID ) )
  		return false;
--- 4255,4261 ----
   */
  function wp_get_attachment_thumb_url( $post_id = 0 ) {
  	$post_id = (int) $post_id;
! 	if ( !$post = get_post( $post_id ) )
  		return false;
  	if ( !$url = wp_get_attachment_url( $post->ID ) )
  		return false;
***************
*** 4025,4031 ****
   */
  function wp_attachment_is_image( $post_id = 0 ) {
  	$post_id = (int) $post_id;
! 	if ( !$post =& get_post( $post_id ) )
  		return false;
  
  	if ( !$file = get_attached_file( $post->ID ) )
--- 4282,4288 ----
   */
  function wp_attachment_is_image( $post_id = 0 ) {
  	$post_id = (int) $post_id;
! 	if ( !$post = get_post( $post_id ) )
  		return false;
  
  	if ( !$file = get_attached_file( $post->ID ) )
***************
*** 4033,4039 ****
  
  	$ext = preg_match('/\.([^.]+)$/', $file, $matches) ? strtolower($matches[1]) : false;
  
! 	$image_exts = array('jpg', 'jpeg', 'gif', 'png');
  
  	if ( 'image/' == substr($post->post_mime_type, 0, 6) || $ext && 'import' == $post->post_mime_type && in_array($ext, $image_exts) )
  		return true;
--- 4290,4296 ----
  
  	$ext = preg_match('/\.([^.]+)$/', $file, $matches) ? strtolower($matches[1]) : false;
  
! 	$image_exts = array( 'jpg', 'jpeg', 'jpe', 'gif', 'png' );
  
  	if ( 'image/' == substr($post->post_mime_type, 0, 6) || $ext && 'import' == $post->post_mime_type && in_array($ext, $image_exts) )
  		return true;
***************
*** 4051,4062 ****
  function wp_mime_type_icon( $mime = 0 ) {
  	if ( !is_numeric($mime) )
  		$icon = wp_cache_get("mime_type_icon_$mime");
  	if ( empty($icon) ) {
- 		$post_id = 0;
  		$post_mimes = array();
  		if ( is_numeric($mime) ) {
  			$mime = (int) $mime;
! 			if ( $post =& get_post( $mime ) ) {
  				$post_id = (int) $post->ID;
  				$ext = preg_replace('/^.+?\.([^.]+)$/', '$1', $post->guid);
  				if ( !empty($ext) ) {
--- 4308,4320 ----
  function wp_mime_type_icon( $mime = 0 ) {
  	if ( !is_numeric($mime) )
  		$icon = wp_cache_get("mime_type_icon_$mime");
+ 
+ 	$post_id = 0;
  	if ( empty($icon) ) {
  		$post_mimes = array();
  		if ( is_numeric($mime) ) {
  			$mime = (int) $mime;
! 			if ( $post = get_post( $mime ) ) {
  				$post_id = (int) $post->ID;
  				$ext = preg_replace('/^.+?\.([^.]+)$/', '$1', $post->guid);
  				if ( !empty($ext) ) {
***************
*** 4098,4104 ****
  					closedir($dh);
  				}
  			}
! 			wp_cache_set('icon_files', $icon_files, 600);
  		}
  
  		// Icon basename - extension = MIME wildcard
--- 4356,4362 ----
  					closedir($dh);
  				}
  			}
! 			wp_cache_add( 'icon_files', $icon_files, 'default', 600 );
  		}
  
  		// Icon basename - extension = MIME wildcard
***************
*** 4118,4124 ****
  			if ( isset($types[$wilds[0]])) {
  				$icon = $types[$wilds[0]];
  				if ( !is_numeric($mime) )
! 					wp_cache_set("mime_type_icon_$mime", $icon);
  				break;
  			}
  		}
--- 4376,4382 ----
  			if ( isset($types[$wilds[0]])) {
  				$icon = $types[$wilds[0]];
  				if ( !is_numeric($mime) )
! 					wp_cache_add("mime_type_icon_$mime", $icon);
  				break;
  			}
  		}
***************
*** 4195,4203 ****
   * @param string $post_type Post type.
   * @param bool $full Optional. Returns a full WHERE statement instead of just an 'andalso' term.
   * @param int $post_author Optional. Query posts having a single author ID.
   * @return string SQL WHERE code that can be added to a query.
   */
! function get_posts_by_author_sql( $post_type, $full = true, $post_author = null ) {
  	global $user_ID, $wpdb;
  
  	// Private posts
--- 4453,4462 ----
   * @param string $post_type Post type.
   * @param bool $full Optional. Returns a full WHERE statement instead of just an 'andalso' term.
   * @param int $post_author Optional. Query posts having a single author ID.
+  * @param bool $public_only Optional. Only return public posts. Skips cap checks for $current_user.  Default is false.
   * @return string SQL WHERE code that can be added to a query.
   */
! function get_posts_by_author_sql( $post_type, $full = true, $post_author = null, $public_only = false ) {
  	global $user_ID, $wpdb;
  
  	// Private posts
***************
*** 4221,4238 ****
  
  	$sql .= "(post_status = 'publish'";
  
! 	if ( current_user_can( $cap ) ) {
! 		// Does the user have the capability to view private posts? Guess so.
! 		$sql .= " OR post_status = 'private'";
! 	} elseif ( is_user_logged_in() ) {
! 		// Users can view their own private posts.
! 		$id = (int) $user_ID;
! 		if ( null === $post_author || ! $full ) {
! 			$sql .= " OR post_status = 'private' AND post_author = $id";
! 		} elseif ( $id == (int) $post_author ) {
  			$sql .= " OR post_status = 'private'";
  		} // else none
! 	} // else none
  
  	$sql .= ')';
  
--- 4480,4500 ----
  
  	$sql .= "(post_status = 'publish'";
  
! 	// Only need to check the cap if $public_only is false
! 	if ( false === $public_only ) {
! 		if ( current_user_can( $cap ) ) {
! 			// Does the user have the capability to view private posts? Guess so.
  			$sql .= " OR post_status = 'private'";
+ 		} elseif ( is_user_logged_in() ) {
+ 			// Users can view their own private posts.
+ 			$id = (int) $user_ID;
+ 			if ( null === $post_author || ! $full ) {
+ 				$sql .= " OR post_status = 'private' AND post_author = $id";
+ 			} elseif ( $id == (int) $post_author ) {
+ 				$sql .= " OR post_status = 'private'";
+ 			} // else none
  		} // else none
! 	}
  
  	$sql .= ')';
  
***************
*** 4351,4358 ****
   * Cleaning means delete from the cache of the post. Will call to clean the term
   * object cache associated with the post ID.
   *
-  * clean_post_cache() will call itself recursively for each child post.
-  *
   * This function not run if $_wp_suspend_cache_invalidation is not empty. See
   * wp_suspend_cache_invalidation().
   *
--- 4613,4618 ----
***************
*** 4383,4405 ****
  
  	do_action( 'clean_post_cache', $post->ID, $post );
  
  	if ( 'page' == $post->post_type ) {
  		wp_cache_delete( 'all_page_ids', 'posts' );
- 		wp_cache_delete( 'get_pages', 'posts' );
  		do_action( 'clean_page_cache', $post->ID );
  	}
- 
- 	if ( $children = $wpdb->get_results( $wpdb->prepare("SELECT ID, post_type FROM $wpdb->posts WHERE post_parent = %d", $post->ID) ) ) {
- 		foreach ( $children as $child ) {
- 			// Loop detection
- 			if ( $child->ID == $post->ID )
- 				continue;
- 			clean_post_cache( $child );
- 		}
- 	}
- 
- 	if ( is_multisite() )
- 		wp_cache_delete( $wpdb->blogid . '-' . $post->ID, 'global-posts' );
  }
  
  /**
--- 4643,4655 ----
  
  	do_action( 'clean_post_cache', $post->ID, $post );
  
+ 	if ( is_post_type_hierarchical( $post->post_type ) )
+ 		wp_cache_delete( 'get_pages', 'posts' );
+ 
  	if ( 'page' == $post->post_type ) {
  		wp_cache_delete( 'all_page_ids', 'posts' );
  		do_action( 'clean_page_cache', $post->ID );
  	}
  }
  
  /**
***************
*** 4430,4437 ****
  	foreach ( $posts as $post )
  		$post_ids[] = $post->ID;
  
! 	if ( empty($post_type) )
! 		$post_type = 'post';
  
  	if ( $update_term_cache ) {
  		if ( is_array($post_type) ) {
--- 4680,4687 ----
  	foreach ( $posts as $post )
  		$post_ids[] = $post->ID;
  
! 	if ( ! $post_type )
! 		$post_type = 'any';
  
  	if ( $update_term_cache ) {
  		if ( is_array($post_type) ) {
***************
*** 4571,4579 ****
   * @since 2.3.0
   * @access private
   * @uses $wpdb
!  * @uses XMLRPC_REQUEST and APP_REQUEST constants.
   * @uses do_action() Calls 'xmlprc_publish_post' on post ID if XMLRPC_REQUEST is defined.
-  * @uses do_action() Calls 'app_publish_post' on post ID if APP_REQUEST is defined.
   *
   * @param int $post_id The ID in the database table of the post being published
   */
--- 4821,4828 ----
   * @since 2.3.0
   * @access private
   * @uses $wpdb
!  * @uses XMLRPC_REQUEST constant.
   * @uses do_action() Calls 'xmlprc_publish_post' on post ID if XMLRPC_REQUEST is defined.
   *
   * @param int $post_id The ID in the database table of the post being published
   */
***************
*** 4582,4589 ****
  
  	if ( defined('XMLRPC_REQUEST') )
  		do_action('xmlrpc_publish_post', $post_id);
- 	if ( defined('APP_REQUEST') )
- 		do_action('app_publish_post', $post_id);
  
  	if ( defined('WP_IMPORTING') )
  		return;
--- 4831,4836 ----
***************
*** 4596,4653 ****
  }
  
  /**
-  * Hook used to prevent page/post cache from staying dirty when a post is saved.
-  *
-  * @since 2.3.0
-  * @access private
-  *
-  * @param int $post_id The ID in the database table for the $post
-  * @param object $post Object type containing the post information
-  */
- function _save_post_hook( $post_id, $post ) {
- 	clean_post_cache( $post );
- }
- 
- /**
-  * Retrieve post ancestors and append to post ancestors property.
-  *
-  * Will only retrieve ancestors once, if property is already set, then nothing
-  * will be done. If there is not a parent post, or post ID and post parent ID
-  * are the same then nothing will be done.
-  *
-  * The parameter is passed by reference, so nothing needs to be returned. The
-  * property will be updated and can be referenced after the function is
-  * complete. The post parent will be an ancestor and the parent of the post
-  * parent will be an ancestor. There will only be two ancestors at the most.
-  *
-  * @since 2.5.0
-  * @access private
-  * @uses $wpdb
-  *
-  * @param object $_post Post data.
-  * @return null When nothing needs to be done.
-  */
- function _get_post_ancestors(&$_post) {
- 	global $wpdb;
- 
- 	if ( isset($_post->ancestors) )
- 		return;
- 
- 	$_post->ancestors = array();
- 
- 	if ( empty($_post->post_parent) || $_post->ID == $_post->post_parent )
- 		return;
- 
- 	$id = $_post->ancestors[] = (int) $_post->post_parent;
- 	while ( $ancestor = $wpdb->get_var( $wpdb->prepare("SELECT `post_parent` FROM $wpdb->posts WHERE ID = %d LIMIT 1", $id) ) ) {
- 		// Loop detection: If the ancestor has been seen before, break.
- 		if ( ( $ancestor == $_post->ID ) || in_array($ancestor,  $_post->ancestors) )
- 			break;
- 		$id = $_post->ancestors[] = (int) $ancestor;
- 	}
- }
- 
- /**
   * Determines which fields of posts are to be saved in revisions.
   *
   * Does two things. If passed a post *array*, it will return a post array ready
--- 4843,4848 ----
***************
*** 4726,4731 ****
--- 4921,4929 ----
  	if ( !$post = get_post( $post_id, ARRAY_A ) )
  		return;
  
+ 	if ( 'auto-draft' == $post['post_status'] )
+ 		return;
+ 
  	if ( !post_type_supports($post['post_type'], 'revisions') )
  		return;
  
***************
*** 4890,4896 ****
   * @param string $filter Optional sanitation filter. @see sanitize_post()
   * @return mixed Null if error or post object if success
   */
! function &wp_get_post_revision(&$post, $output = OBJECT, $filter = 'raw') {
  	$null = null;
  	if ( !$revision = get_post( $post, OBJECT, $filter ) )
  		return $revision;
--- 5088,5094 ----
   * @param string $filter Optional sanitation filter. @see sanitize_post()
   * @return mixed Null if error or post object if success
   */
! function wp_get_post_revision(&$post, $output = OBJECT, $filter = 'raw') {
  	$null = null;
  	if ( !$revision = get_post( $post, OBJECT, $filter ) )
  		return $revision;
***************
*** 5166,5175 ****
  	$post = get_post( $post );
  	$thumbnail_id = absint( $thumbnail_id );
  	if ( $post && $thumbnail_id && get_post( $thumbnail_id ) ) {
! 		$thumbnail_html = wp_get_attachment_image( $thumbnail_id, 'thumbnail' );
! 		if ( ! empty( $thumbnail_html ) ) {
  			return update_post_meta( $post->ID, '_thumbnail_id', $thumbnail_id );
! 		}
  	}
  	return false;
  }
--- 5364,5373 ----
  	$post = get_post( $post );
  	$thumbnail_id = absint( $thumbnail_id );
  	if ( $post && $thumbnail_id && get_post( $thumbnail_id ) ) {
! 		if ( $thumbnail_html = wp_get_attachment_image( $thumbnail_id, 'thumbnail' ) )
  			return update_post_meta( $post->ID, '_thumbnail_id', $thumbnail_id );
! 		else
! 			return delete_post_meta( $post->ID, '_thumbnail_id' );
  	}
  	return false;
  }
